/*
 * Copyright (C) 2002, 2003 Emmanuel Saracco <esaracco@noos.fr>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#include "cache.h"


/*
 * return the source code of the given link id
 */
gchar *
uc_cache_get_source (const guint id)
{
  gchar *buffer = NULL;
  gchar *path = NULL;

  if (!(path = uc_utils_convert_uid2file (id)))
    return NULL;

  buffer = uc_utils_get_file_content (path);

  g_free (path);
  return buffer;
}


/*
 * put a source page in the cache
 */
void
uc_cache_append_source (const guint id, gchar * src, const guint length)
{
  FILE *fd;
  gchar *path = NULL;
  gchar *src_tmp = NULL;

  if ((!src) || (!strlen (src)) || (!(path = uc_utils_convert_uid2file (id))))
    return;

  /* pass HTTP header */
  src_tmp = uc_utils_search_string_next (src, "\r\n\r\n", '<');

  if (src_tmp)
    {
      fd = fopen (path, "w");
      fwrite (src_tmp, 1, length, fd);
      fclose (fd);
    }

  g_free (path);
}
