/* 
 * Copyright (C) 2002, 2003 Emmanuel Saracco <esaracco@noos.fr>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, 
 * Boston, MA 02111-1307, USA. 
 */

#include "callbacks.h"


void
on_view_link_content_activate (GtkMenuItem * menuitem, gpointer user_data)
{
  uc_application_view_source_dialog_show ();
}

void
on_quit_activate (GtkMenuItem * menuitem, gpointer user_data)
{
  uc_application_quit ();
}


void
on_about_activate (GtkMenuItem * menuitem, gpointer user_data)
{
  uc_application_about_dialog_show ();
}


void
on_settings_activate (GtkMenuItem * menuitem, gpointer user_data)
{
  uc_application_settings_dialog_show ();
}


void
on_display_badlinks_activate (GtkMenuItem * menuitem, gpointer user_data)
{
  uc_application_main_tree_display_badlinks ();
}


void
on_display_goodlinks_activate (GtkMenuItem * menuitem, gpointer user_data)
{
  uc_application_main_tree_display_goodlinks ();
}


void
on_display_timeouts_activate (GtkMenuItem * menuitem, gpointer user_data)
{
  uc_application_main_tree_display_timeouts ();
}


void
on_display_malformed_activate (GtkMenuItem * menuitem, gpointer user_data)
{
  uc_application_main_tree_display_malformedlinks ();
}


void
on_display_all_activate (GtkMenuItem * menuitem, gpointer user_data)
{
  uc_application_main_tree_display_all ();
}


void
on_display_collapse_all_activate (GtkMenuItem * menuitem, gpointer user_data)
{
  uc_application_main_tree_collapse_all ();
}


void
on_display_expand_all_activate (GtkMenuItem * menuitem, gpointer user_data)
{
  uc_application_main_tree_expand_all ();
}


void
on_btcancel_new_web_project_dialog_clicked (GtkButton * button,
					    gpointer user_data)
{
  gtk_widget_destroy (new_project_dialog);
}


void
on_btok_new_web_project_dialog_clicked (GtkButton * button,
					gpointer user_data)
{
  uc_application_get_web_project_data ();
}


void
on_btCancel_settingsDialog_clicked (GtkButton * button, gpointer user_data)
{
  gtk_widget_destroy (settings_dialog);
}


void
on_btOk_settingsDialog_clicked (GtkButton * button, gpointer user_data)
{
  if (uc_application_settings_get_data ())
    gtk_widget_destroy (settings_dialog);
}


void
on_btNewProject_clicked (GtkButton * button, gpointer user_data)
{
  uc_application_new_web_dialog_show ();
}


void
on_mainWindow_destroy (GtkObject * object, gpointer user_data)
{
  uc_application_quit ();
}

gboolean
on_mainWindow_configure_event (GtkContainer * container, gpointer user_data)
{
  uc_application_resize ();

  return FALSE;
}

void
on_btApply_settingsDialog_clicked (GtkButton * button, gpointer user_data)
{
  uc_application_settings_get_data ();
}

void
on_urlsList_cursorChanged (GtkTreeView * selection, gpointer user_data)
{
  uc_application_display_informations (selection);
}

void
on_search_list_cursor_changed (GtkTreeView * selection, gpointer user_data)
{
  uc_search_main_select (selection);
}

gboolean
on_urlList_mouseClicked (GtkWidget * widget, GdkEventButton * event,
			 gpointer data)
{
  /* show page properties on left
   * double-click */
  if (event->type == GDK_2BUTTON_PRESS)
    uc_application_page_information_dialog_show ();

  /* show contextual popup menu on right
   * button release */
  else if ((event->type == GDK_BUTTON_RELEASE) && (event->button == 3))
    uc_application_treeview_activate_popup (event);

  return FALSE;
}

void
on_btCancel_progressDialog_clicked (GtkButton * button, gpointer user_data)
{
  uc_check_cancel_set_value (TRUE);
}

void
on_btIgnore_progressDialog_clicked (GtkButton * button, gpointer user_data)
{
  uc_check_ignore_item_set_value (TRUE);
}

void
on_progressDialog_close (GtkDialog * dialog, gpointer user_data)
{
  uc_check_cancel_set_value (TRUE);
}

gboolean
on_progressDialog_destroy_event (GtkWidget * widget,
				 GdkEvent * event, gpointer user_data)
{
  uc_check_cancel_set_value (TRUE);
  return TRUE;
}


gboolean
on_progressDialog_delete_event (GtkWidget * widget,
				GdkEvent * event, gpointer user_data)
{
  uc_check_cancel_set_value (TRUE);
  return TRUE;
}


void
on_progressDialog_destroy (GtkObject * object, gpointer user_data)
{
  uc_check_cancel_set_value (TRUE);
}


void
on_btBasicDisplayFormat_clicked (GtkButton * button, gpointer user_data)
{
  uc_application_display_informations (GTK_TREE_VIEW (user_data));
}

void
on_btDetailedDisplayFormat_clicked (GtkButton * button, gpointer user_data)
{
  uc_application_display_informations (GTK_TREE_VIEW (user_data));
}

void
on_bt_Close_viewSource_clicked (GtkButton * button, gpointer user_data)
{
  gtk_widget_destroy (view_source_dialog);
}

gboolean
on_entryProjectURL_key_press_event (GtkWidget * widget,
				    GdkEventKey * event, gpointer user_data)
{
  if (event->keyval != GDK_Return)
    return FALSE;

  gtk_widget_activate (glade_xml_get_widget
		       (glade_new_project_dialog, "btok"));

  return TRUE;
}

void
on_bt_gconf_proxy_clicked (GtkButton * button, gpointer user_data)
{
  uc_application_proxy_launch_gnome_pref ();
}

void
on_new_instance_activate (GtkMenuItem * menuitem, gpointer user_data)
{
  uc_application_new_instance_launch ();
}

void
on_btSuspend_progressDialog_clicked (GtkButton * button, gpointer user_data)
{
  uc_check_suspend_continue ();
}


void
on_bt_Close_similarLinks_clicked (GtkButton * button, gpointer user_data)
{
  gtk_widget_destroy (similar_links_dialog);
}


void on_view_similar_link_locations_activate
  (GtkMenuItem * menuitem, gpointer user_data)
{
  uc_application_view_similar_links_dialog_show ();

}

void
on_view_online_activate (GtkMenuItem * menuitem, gpointer user_data)
{
  UCLinkProperties *prop = NULL;
  gint id = 0;

  if ((id = uc_check_treeview_get_selected_row_id ()) >= 0)
    {
      prop = uc_lists_checked_links_lookup_by_uid (id);
      uc_application_launch_web_browser (prop->url);
    }
  else
    uc_application_dialog_show (_
				("Please, select a item first."),
				GTK_MESSAGE_WARNING);
}

void
on_page_properties_activate (GtkMenuItem * menuitem, gpointer user_data)
{
  gint id = 0;

  if ((id = uc_check_treeview_get_selected_row_id ()) >= 0)
    uc_application_page_information_dialog_show ();
  else
    uc_application_dialog_show (_
				("Please, select a item first."),
				GTK_MESSAGE_WARNING);
}


void
on_view_parent_page_online_activate (GtkMenuItem * menuitem,
				     gpointer user_data)
{
  UCLinkProperties *prop = NULL;
  gchar *parent_url = NULL;
  gint id = 0;

  if ((id = uc_check_treeview_get_selected_row_id ()) >= 0)
    {
      prop = uc_lists_checked_links_lookup_by_uid (id);
      parent_url = (prop->parent) ? (prop->parent)->url :
	uc_project_get_url ();
      uc_application_launch_web_browser (parent_url);
    }
  else
    uc_application_dialog_show (_
				("Please, select a item first."),
				GTK_MESSAGE_WARNING);
}

void
on_bt_close_page_information_clicked (GtkButton * button, gpointer user_data)
{
  gtk_widget_destroy (page_information_dialog);
}


void on_btCancel_addFilterDirectoryDialog_clicked
  (GtkButton * button, gpointer user_data)
{
  gtk_widget_destroy (add_filter_directory_dialog);
}


void on_btOk_addFilterDirectoryDialog_clicked
  (GtkButton * button, gpointer user_data)
{

}


void on_btCancel_addFilterDomainDialog_clicked
  (GtkButton * button, gpointer user_data)
{
  gtk_widget_destroy (add_filter_domain_dialog);
}


void
on_btOk_addFilterDomainDialog_clicked (GtkButton * button, gpointer user_data)
{
}


void
on_bt_add_filter_directory_clicked (GtkButton * button, gpointer user_data)
{
  uc_application_add_filter_directory_dialog_show ();
}


void
on_bt_add_filter_domain_clicked (GtkButton * button, gpointer user_data)
{
  uc_application_add_filter_domain_dialog_show ();
}


gboolean on_entry_add_filter_directory_key_press_event
  (GtkWidget * widget, GdkEventKey * event, gpointer user_data)
{
  if (event->keyval != GDK_Return)
    return FALSE;

  gtk_widget_activate (glade_xml_get_widget
		       (glade_add_filter_directory_dialog,
			"bt_add_add_filter_directory_dialog"));

  return TRUE;
}


void on_bt_add_add_filter_directory_dialog_clicked
  (GtkButton * button, gpointer user_data)
{
  uc_application_add_filter_directory_add ();
}


void on_bt_add_add_filter_domain_dialog_clicked
  (GtkButton * button, gpointer user_data)
{
  uc_application_add_filter_domain_add ();
}


gboolean on_entry_add_filter_domain_key_press_event
  (GtkWidget * widget, GdkEventKey * event, gpointer user_data)
{
  if (event->keyval != GDK_Return)
    return FALSE;

  gtk_widget_activate (glade_xml_get_widget
		       (glade_add_filter_domain_dialog,
			"bt_add_add_filter_domain_dialog"));

  return TRUE;
}


void
on_bt_remove_filter_domain_clicked (GtkButton * button, gpointer user_data)
{
  uc_application_add_filter_domain_remove ();
}


void
on_bt_remove_filter_directory_clicked (GtkButton * button, gpointer user_data)
{
  uc_application_add_filter_directory_remove ();
}


void
on_bt_clear_filter_directory_clicked (GtkButton * button, gpointer user_data)
{
  gtk_list_store_clear (treestore_filter_directories);
}


void
on_bt_clear_filter_domain_clicked (GtkButton * button, gpointer user_data)
{
  gtk_list_store_clear (treestore_filter_domains);
}

void
on_check_email_address_clicked (GtkButton * button, gpointer user_data)
{
  GtkWidget *widget1 = NULL;
  GtkWidget *widget2 = NULL;
  gboolean active = FALSE;

  widget1 =
    glade_xml_get_widget (glade_settings_dialog, "check_email_address");
  widget2 = glade_xml_get_widget (glade_settings_dialog, "check_email_mx");

  if (!(active = gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (widget1))))
    gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (widget2), FALSE);

  gtk_widget_set_sensitive (GTK_WIDGET (widget2), active);
}


void
on_menu_check_email_mx_activate (GtkMenuItem * menuitem, gpointer user_data)
{
  uc_check_mx_is_valid ();
}

void
on_image_preview_activate (GtkMenuItem * menuitem, gpointer user_data)
{
  uc_application_view_image_dialog_show ();
}


void
on_bt_Close_imagePreview_clicked (GtkButton * button, gpointer user_data)
{
  gtk_widget_destroy (view_image_dialog);
}

void
  on_dynamic_values_time_between_value_changed
  (GtkSpinButton * spinbutton, gpointer user_data)
{
  GtkWidget *widget = NULL;

  widget =
    glade_xml_get_widget (glade_progress_dialog,
			  "dynamic_values_time_between");

  uc_project_set_check_wait ((guint)
			     gtk_spin_button_get_value (GTK_SPIN_BUTTON
							(widget)));
}


void
  on_dynamic_values_timeout_value_changed
  (GtkSpinButton * spinbutton, gpointer user_data)
{
  GtkWidget *widget = NULL;

  widget =
    glade_xml_get_widget (glade_progress_dialog, "dynamic_values_timeout");

  uc_project_set_check_timeout ((guint)
				gtk_spin_button_get_value (GTK_SPIN_BUTTON
							   (widget)));
}

void
on_search_activate (GtkMenuItem * menuitem, gpointer user_data)
{
  uc_application_new_search_dialog_show ();
}


void
on_new_search_button_clicked (GtkButton * button, gpointer user_data)
{
  uc_application_search_get_data ();
}


void
on_new_search_cancel_clicked (GtkButton * button, gpointer user_data)
{
  gtk_widget_destroy (new_search_dialog);
}


void
on_search_close_clicked (GtkButton * button, gpointer user_data)
{
  uc_search_set_exit (TRUE);

  gtk_widget_destroy (search_dialog);
  uc_application_menu_set_sensitive_all ("search", TRUE);
}


void
on_clear_project_history_clicked (GtkButton * button, gpointer user_data)
{
  gnome_entry_clear_history (GNOME_ENTRY (gnome_entry_new ("1")));
}


void
on_clear_search_history_clicked (GtkButton * button, gpointer user_data)
{
  gnome_entry_clear_history (GNOME_ENTRY (gnome_entry_new ("2")));
}


void
on_new_search_check_button_toggled (GtkToggleButton * togglebutton,
				    gpointer user_data)
{
  uc_search_check_verification ();
}

gboolean
on_search_dialog_delete_event (GtkWidget * widget,
			       GdkEvent * event, gpointer user_data)
{
  uc_search_set_exit (TRUE);

  uc_application_menu_set_sensitive_all ("search", TRUE);
  return FALSE;
}


gboolean
on_combo_search_key_press_event (GtkWidget * widget,
				 GdkEventKey * event, gpointer user_data)
{
  if (event->keyval != GDK_Return)
    return FALSE;

  gtk_widget_activate (glade_xml_get_widget
		       (glade_new_search_dialog, "bt_search"));

  return TRUE;
}

void
on_web_site_activate (GtkMenuItem * menuitem, gpointer user_data)
{
  uc_application_new_web_dialog_show ();
}


void
on_local_file_activate (GtkMenuItem * menuitem, gpointer user_data)
{

}


void
on_bookmarks_file_activate (GtkMenuItem * menuitem, gpointer user_data)
{
  uc_application_new_bookmarks_dialog_show ();
}

void
on_btcancel_new_bookmarks_project_clicked (GtkButton * button,
					   gpointer user_data)
{
  gtk_widget_destroy (new_project_dialog);
}


void
on_btok_new_bookmarks_project_clicked (GtkButton * button, gpointer user_data)
{
  uc_application_get_bookmarks_project_data ();
}

gboolean
on_bookmarks_key_press_event (GtkWidget * widget,
			      GdkEventKey * event, gpointer user_data)
{
  if (event->keyval != GDK_Return)
    return FALSE;

  gtk_widget_activate (glade_xml_get_widget
		       (glade_new_project_dialog, "btok"));

  return TRUE;
}

void
on_delete_link_activate (GtkMenuItem * menuitem, gpointer user_data)
{
  gint id = 0;

  if ((id = uc_check_treeview_get_selected_row_id ()) >= 0)
    uc_bookmarks_delete_link (id);
  else
    uc_application_dialog_show (_
				("Please, select a item first."),
				GTK_MESSAGE_WARNING);
}

void
on_save_bookmarks_activate (GtkMenuItem * menuitem, gpointer user_data)
{
  uc_application_save_bookmarks ();
}
